
/*

  Form bilinears from an S_1 ``source'' format file (for testing).

*/

#include <stdio.h>
#include "datahdr.h"
#include "strmhdr.h"

static char *usage        = "USAGE: slbilins <state> <file>\n" ;

extern void sums () ;

void get_params (state, file, argc, argv)
char **state, **file ;
int argc ;
char *argv [] ;
{
  if (argc != 3)
  {
    fprintf (stderr, usage) ;
    exit (1) ;
  }
  *state = argv [1] ;

  if (! strcmp (argv [2], "-"))
    *file = NULL ;
  else
    *file = argv [2] ;
}

void main (argc, argv)
int argc ;
char *argv [] ;
{
  char *state, *file ;
  DATA *datas, *data ;
  int   paramss [NUM_STT_PARAMS] ;
  float coeffss [NUM_STT_COEFFS] ;
  int   params  [1] ;
  float coeffs  [1] ;
  int l_time, l_space ;

  get_params  (&state, &file, argc, argv) ;

  datas = data_open_read (state) ;
  read_header (datas) ;
  read_coeffs (datas, coeffss) ;
  read_params (datas, paramss) ;
  data_close  (datas) ;

  data = data_open_read (file) ;
  read_header (data) ;
  read_coeffs (data, coeffs) ;
  read_params (data, params) ;

  fprintf (stdout, "%d\n", paramss [STT_L_T]) ;
  fprintf (stdout, "%d\n", params  [0      ]) ;
  fprintf (stdout, "\n") ;

  l_time  = paramss [STT_L_T] ;
  l_space = paramss [STT_L_X] * paramss [STT_L_Y] * paramss [STT_L_Z] ;

  read_field_begin (data) ;
  sums (data, l_time, l_space) ;

  data_close (data) ;
}

